﻿using FitConnect;
using FitConnect.Models;
using Microsoft.Extensions.Logging;

const string destinationId = "aa3704d6-8bd7-4d40-a8af-501851f93934";
const string leikaKey = "urn:de:fim:leika:leistung:99400048079000";
const string clientSecret = "rdlXms-4ikO47AbTmmCTdzFoE4cTSt13JmSbcY5Dhsw";
const string clientId = "73a8ff88-076b-4263-9a80-8ebadac97b0d";

var logger = LoggerFactory.Create(
    builder => {
        builder.AddSimpleConsole();
        builder.SetMinimumLevel(LogLevel.Information);
    }).CreateLogger("FluentSenderTests");

logger.Log(LogLevel.Information,
    "This is a dummy client to demonstrate the usage of the FIT-Connect SDK for .NET");


void FluentSenderCall() {
    new Client(
            FitConnectEndpoints.Create(FitConnectEndpoints.EndpointType.Development),
            clientId, clientSecret,
            logger: logger).GetSender()
        .WithDestination(destinationId)
        .WithServiceType("ServiceName", leikaKey)
        .WithAttachments(new List<Attachment>() {
            new Attachment("Test.pdf", "The description of the attachment")
        })
        .WithData("{\"data\":\"value\"}")
        .Submit();
}

void FluentSubscriberCall() {
    var client = new Client(
        FitConnectEndpoints.Create(FitConnectEndpoints.EndpointType.Development),
        clientId, clientSecret,
        logger: logger);
}

FluentSenderCall();
// FluentSubscriberCall();
