using FitConnect.Models;

namespace FitConnect.Interfaces;

public interface IFluentSender {
    public string PublicKey { get; }

    /// <summary>
    /// Determines the destination id and configures the sender.
    /// </summary>
    /// <param name="leiaKey"></param>
    /// <param name="ags"></param>
    /// <param name="ars"></param>
    /// <param name="areaId"></param>
    /// <returns></returns>
    public IFluentSenderWithDestination FindDestinationId(string leiaKey, string? ags, string? ars,
        string? areaId);

    /// <summary>
    ///     Configures the client for the given destination and load the public key
    /// </summary>
    /// <param name="destinationId">unique identifier of the clients destination</param>
    /// <returns>the upload step for attachments</returns>
    public IFluentSenderWithDestination WithDestination(string destinationId);
    
    
    public IFluentSenderWithService WithService(string serviceName, string leikaKey );

    public IFluentSenderWithData WithData(string data);
}
